#ifndef YERBACON_RESERVEDIDENTIFIERS_HPP
#define YERBACON_RESERVEDIDENTIFIERS_HPP

#include <string>
#include <array>
#include "../Yerbacon.hpp"
#include <string_view>

static const array identifiers {
    "class", "structure", "print", "print_line"
};

enum class ReservedIdentifier: size_t {
    CLASS, STRUCT, PRINT_FUNCTION, PRINT_LINE_FUNCTION
};

inline const char* ID(const ReservedIdentifier& identifier) {
    return identifiers.at(reinterpret_cast<const size_t&>(identifier));
}

bool reserved(const string_view words) {
    return find(identifiers.cbegin(), identifiers.cend(), words) != identifiers.cend();
}

#endif //YERBACON_RESERVEDIDENTIFIERS_HPP
